OpenTTD Source: NewGRFWindow Struct Reference

OpenTTD Source 15.3

Public Types | Public Member Functions | Data Fields | Static Public Attributes | Private Member Functions | Static Private Member Functions
NewGRFWindow Struct Reference

Window for showing NewGRF files. More...

Inheritance diagram for NewGRFWindow:

## Public Types
typedef GUIList< const GRFConfig *, std::nullptr_t, StringFilter & > | GUIGRFConfigList
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.

## Public Member Functions
| NewGRFWindow (WindowDesc &desc, bool editable, bool show_params, bool execute, GRFConfigList &orig_list)
void | Close (int data=0) override
| Hide the window and all its child windows, and mark them for a later deletion.
int | GetCurrentActivePosition () const
bool | CanUpgradeCurrent ()
| Test whether the currently active set of NewGRFs can be upgraded with the available NewGRFs.
void | UpgradeCurrent ()
| Upgrade the currently active set of NewGRFs.
void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize) override
| Update size and resize step of a widget in the window.
void | OnResize () override
| Called after the window got resized.
std::string | GetWidgetString (WidgetID widget, StringID stringid) const override
| Get the raw string for a widget.
PaletteID | GetPalette (const GRFConfig &c) const
| Pick the palette for the sprite of the grf to display.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
void | OnNewGRFsScanned () override
| Called whenever the NewGRF scan completed.
void | OnDropdownSelect (WidgetID widget, int index, int) override
| A dropdown option associated to this window has been selected.
void | OnQueryTextFinished (std::optional< std::string > str) override
| The query window opened from this window has closed.
void | UpdateScrollBars ()
| Updates the scroll bars for the active and inactive NewGRF lists.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
EventState | OnKeyPress (char32_t key, uint16_t keycode) override
| A key has been pressed.
void | OnEditboxChanged (WidgetID widget) override
| The text in an editbox has been edited.
void | OnDragDrop (Point pt, WidgetID widget) override
| A dragged 'object' has been released.
void | OnMouseDrag (Point pt, WidgetID widget) override
| An 'object' is being dragged at the provided position, highlight the target if possible.
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (size_t from, size_t to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, std::string_view str, bool marked, std::optional< size_t > caret, std::optional< size_t > insert_location, std::optional< size_t > replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
Window * | FindChildWindowById (WindowClass wc, WindowNumber number) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
void | CloseChildWindowById (WindowClass wc, WindowNumber number) const
| Close all children a window might have in a head-recursive manner.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, WidgetID widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnScrollbarScroll (WidgetID widget)
| Notify window that a scrollbar position has been updated.
virtual void | OnMouseOver (Point pt, WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel, WidgetID widget)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, int click_result, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
Public Member Functions inherited from NewGRFScanCallback
virtual | ~NewGRFScanCallback ()=default
| Make sure the right destructor gets called.

## Data Fields
GUIGRFConfigList | avails {}
| Available (non-active) grfs.
const GRFConfig * | avail_sel = nullptr
| Currently selected available grf. `nullptr` is none is selected.
int | avail_pos = -1
| Index of avail_sel if existing, else `-1`.
StringFilter | string_filter {}
| Filter for available grf.
QueryString | filter_editbox
| Filter editbox;.
StringList | grf_presets {}
| List of known NewGRF presets.
GRFConfigList | actives {}
| Temporary active grf list to which changes are made.
GRFConfig * | active_sel = nullptr
| Selected active grf item.
GRFConfigList & | orig_list
| List active grfs in the game. Used as initial value, may be updated by the window.
bool | editable = false
| Is the window editable?
bool | show_params = false
| Are the grf-parameters shown in the info-panel?
bool | execute = false
| On pressing 'apply changes' are grf changes applied immediately, or only list is updated.
int | preset = -1
| Selected preset or `-1` if none selected.
int | active_over = -1
| Active GRF item over which another one is dragged, `-1` if none.
bool | modified = false
| The list of active NewGRFs has been modified since the last time they got saved.
Scrollbar * | vscroll = nullptr
Scrollbar * | vscroll2 = nullptr
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags {}
| Window flags.
WindowClass | window_class {}
| Window class.
WindowNumber | window_number = 0
| Window number within the window class.
int | scale = 0
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer = 0
| Timer value of the WindowFlag::Timeout for flags.
uint8_t | white_border_timer = 0
| Timer value of the WindowFlag::WhiteBorder for flags.
int | left = 0
| x position of left edge of the window
int | top = 0
| y position of top edge of the window
int | width = 0
| width of the window (number of pixels to the right in x direction)
int | height = 0
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize {}
| Resize information.
Owner | owner = INVALID_OWNER
| The owner of the content shown in this window. Company colour is acquired from this variable.
std::unique_ptr< ViewportData > | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus = nullptr
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings {}
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root {}
| Root of the nested tree.
WidgetLookup | widget_lookup {}
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select = nullptr
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size {}
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget = INVALID_WIDGET
| ID of current mouse capture widget (e.g. dragged scrollbar). `INVALID_WIDGET` if no widget has mouse capture.
Window * | parent = nullptr
| Parent window.
WindowList::iterator | z_position {}

## Static Public Attributes
static const uint | EDITBOX_MAX_SIZE = 50
static Listing | last_sorting = {false, 0}
| Default sorting of GUIGRFConfigList.
static Filtering | last_filtering = {false, 0}
| Default filtering of GUIGRFConfigList.
static const std::initializer_list< GUIGRFConfigList::SortFunction *const > | sorter_funcs
| Sort functions of the GUIGRFConfigList.
static const std::initializer_list< GUIGRFConfigList::FilterFunction *const > | filter_funcs
| Filter functions of the GUIGRFConfigList.

## Private Member Functions
void | BuildAvailables ()
bool | AddGRFToActive (int ins_pos=-1)
| Insert a GRF into the active list.

## Static Private Member Functions
static bool | NameSorter (const GRFConfig *const &a, const GRFConfig *const &b)
| Sort grfs by name.
static bool | TagNameFilter (const GRFConfig *const *a, StringFilter &filter)
| Filter grfs by tags/name.

## Additional Inherited Members
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height, bool allow_resize)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data {}
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize = false
| Set if window has been resized.

## Detailed Description

Window for showing NewGRF files.

Definition at line 596 of file newgrf_gui.cpp.

## Member Typedef Documentation

## ◆ GUIGRFConfigList

typedef GUIList<const GRFConfig *, std::nullptr_t, StringFilter &> NewGRFWindow::GUIGRFConfigList

Definition at line 597 of file newgrf_gui.cpp.

## Constructor & Destructor Documentation

## ◆ NewGRFWindow()

NewGRFWindow::NewGRFWindow | ( | WindowDesc & | desc,
|  | bool | editable,
|  | bool | show_params,
|  | bool | execute,
|  | GRFConfigList & | orig_list
| ) |  |
| inline

Definition at line 628 of file newgrf_gui.cpp.

## Member Function Documentation

## ◆ AddGRFToActive()

bool NewGRFWindow::AddGRFToActive | ( | int | ins_pos = `-1` | ) |
| inlineprivate

Insert a GRF into the active list.

Parameters

  ins_pos | Insert GRF at this position.

Returns
  True if the GRF was successfully added.

Definition at line 1462 of file newgrf_gui.cpp.

References actives, avails, Window::CloseChildWindows(), GRFConfig::flags, GUIList< T, P, F >::ForceRebuild(), GetEncodedString(), GOID_NEWGRF_LIST_EDITED, GRFIdentifier::grfid, GRFConfig::ident, Invalid, Window::InvalidateData(), NETWORK_MAX_GRF_COUNT, ShowErrorMessage(), Static, BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Test(), WC_TEXTFILE, and WL_INFO.

Referenced by OnClick(), and OnDragDrop().

## ◆ BuildAvailables()

void NewGRFWindow::BuildAvailables | ( |  | ) |
| inlineprivate

Definition at line 1414 of file newgrf_gui.cpp.

## ◆ CanUpgradeCurrent()

bool NewGRFWindow::CanUpgradeCurrent | ( |  | ) |
| inline

Test whether the currently active set of NewGRFs can be upgraded with the available NewGRFs.

Returns
  Whether an upgrade is possible.

Definition at line 690 of file newgrf_gui.cpp.

References _all_grfs, actives, and FillGrfidMap().

## ◆ Close()

void NewGRFWindow::Close | ( | int | data = `0` | ) |
| inlineoverridevirtual

Hide the window and all its child windows, and mark them for a later deletion.

Reimplemented from Window.

Definition at line 663 of file newgrf_gui.cpp.

References actives, Window::Close(), CloseWindowByClass(), CopyGRFConfigList(), ReloadNewGRFData(), ResetGRFConfig(), WC_GRF_PARAMETERS, and WC_SAVE_PRESET.

## ◆ DrawWidget()

void NewGRFWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 835 of file newgrf_gui.cpp.

References _current_text_dir, active_sel, actives, avail_sel, avails, WidgetDimensions::bevel, CentreBounds(), DrawSprite(), DrawString(), GRFConfig::errors, FS_NORMAL, GetCharacterHeight(), GetColourGradient(), GRFConfig::GetName(), GetPalette(), GetSpriteSize(), Scrollbar::GetVisibleRangeIterators(), GfxFillRect(), Scrollbar::IsVisible(), PC_BLACK, PC_DARK_BLUE, PC_DARK_GREY, PC_GREY, SA_HOR_CENTER, WidgetDimensions::scaled, Rect::Shrink(), TD_RTL, Window::top, WID_NS_AVAIL_LIST, WID_NS_FILE_LIST, WID_NS_NEWGRF_INFO, and WID_NS_NEWGRF_INFO_TITLE.

## ◆ GetCurrentActivePosition()

int NewGRFWindow::GetCurrentActivePosition | ( |  | ) | const
| inline

Definition at line 677 of file newgrf_gui.cpp.

## ◆ GetPalette()

PaletteID NewGRFWindow::GetPalette | ( | const GRFConfig & | c | ) | const
| inline

Pick the palette for the sprite of the grf to display.

Parameters

  c | grf to display.

Returns
  Palette for the sprite.

Definition at line 805 of file newgrf_gui.cpp.

References Compatible, GRFConfig::flags, GCS_ACTIVATED, GCS_DISABLED, GCS_NOT_FOUND, Static, GRFConfig::status, and BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Test().

Referenced by DrawWidget().

## ◆ GetWidgetString()

std::string NewGRFWindow::GetWidgetString | ( | WidgetID | widget,
|  | StringID | stringid
| ) |  | const
| inlineoverridevirtual

Get the raw string for a widget.

Calls to this function are also made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.
  stringid | StringID assigned to widget.

Returns
  raw string to display.

Reimplemented from Window.

Definition at line 787 of file newgrf_gui.cpp.

References GetString(), Window::GetWidgetString(), grf_presets, preset, and WID_NS_PRESET_LIST.

## ◆ NameSorter()

static bool NewGRFWindow::NameSorter | ( | const GRFConfig *const & | a,
|  | const GRFConfig *const & | b
| ) |  |
| inlinestaticprivate

Sort grfs by name.

Definition at line 1391 of file newgrf_gui.cpp.

References GRFConfig::GetName(), GRFConfig::ident, GRFIdentifier::md5sum, StrMakeValid(), StrNaturalCompare(), and GRFConfig::version.

## ◆ OnClick()

void NewGRFWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 926 of file newgrf_gui.cpp.

References _network_available, active_sel, actives, AddGRFToActive(), avail_sel, avails, Window::CloseChildWindows(), CloseWindowByClass(), DeleteGRFPresetFromConfig(), GRFConfig::flags, GUIList< T, P, F >::ForceRebuild(), WidgetDimensions::framerect, GetEncodedString(), GetGRFPresetList(), Scrollbar::GetScrolledItemFromWidget(), Scrollbar::GetScrolledRowFromWidget(), GRFConfig::GetURL(), GOID_NEWGRF_CHANGES_MADE, GOID_NEWGRF_LIST_EDITED, grf_presets, GRFP_USE_MASK, HT_DRAG, Invalid, Window::InvalidateData(), NewGRFConfirmationCallback(), GRFConfig::num_valid_params, GRFConfig::palette, preset, RequestNewGRFScan(), ResetObjectToPlace(), WidgetDimensions::scaled, Scrollbar::ScrollTowards(), Window::SetDirty(), SetObjectToPlaceWnd(), ShowDropDownList(), ShowErrorMessage(), ShowMissingContentWindow(), ShowQuery(), ShowSavePresetWindow(), SPR_CURSOR_MOUSE, BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Test(), UpgradeCurrent(), WC_GRF_PARAMETERS, WC_QUERY_STRING, WC_TEXTFILE, WID_NS_ADD, WID_NS_APPLY_CHANGES, WID_NS_AVAIL_LIST, WID_NS_CONTENT_DOWNLOAD, WID_NS_CONTENT_DOWNLOAD2, WID_NS_FILE_LIST, WID_NS_MOVE_DOWN, WID_NS_MOVE_UP, WID_NS_NEWGRF_TEXTFILE, WID_NS_OPEN_URL, WID_NS_PRESET_DELETE, WID_NS_PRESET_LIST, WID_NS_PRESET_SAVE, WID_NS_REMOVE, WID_NS_RESCAN_FILES, WID_NS_RESCAN_FILES2, WID_NS_SET_PARAMETERS, WID_NS_TOGGLE_PALETTE, WID_NS_UPGRADE, WID_NS_VIEW_PARAMETERS, and WL_ERROR.

Referenced by OnDragDrop().

## ◆ OnDragDrop()

void NewGRFWindow::OnDragDrop | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

A dragged 'object' has been released.

Parameters

  pt | the point inside the window where the release took place.
  widget | the widget where the release took place.

Reimplemented from Window.

Definition at line 1324 of file newgrf_gui.cpp.

References actives, AddGRFToActive(), WidgetDimensions::framerect, Scrollbar::GetScrolledRowFromWidget(), GOID_NEWGRF_LIST_EDITED, Window::InvalidateData(), OnClick(), ResetObjectToPlace(), WidgetDimensions::scaled, Scrollbar::ScrollTowards(), Window::SetWidgetDirty(), Slide(), WID_NS_AVAIL_LIST, WID_NS_FILE_LIST, WID_NS_REMOVE, and Coord2D< T >::y.

## ◆ OnDropdownSelect()

void NewGRFWindow::OnDropdownSelect | ( | WidgetID | widget,
|  | int | index,
|  | int | click_result
| ) |  |
| inlineoverridevirtual

A dropdown option associated to this window has been selected.

Parameters

  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 1142 of file newgrf_gui.cpp.

References actives, avails, ClearGRFConfigList(), Window::CloseChildWindows(), CloseWindowByClass(), GUIList< T, P, F >::ForceRebuild(), GOID_NEWGRF_CHANGES_MADE, grf_presets, Window::InvalidateData(), LoadGRFPresetFromConfig(), ResetObjectToPlace(), WC_GRF_PARAMETERS, WC_TEXTFILE, and WID_NS_PRESET_LIST.

## ◆ OnEditboxChanged()

void NewGRFWindow::OnEditboxChanged | ( | WidgetID | widget | ) |
| inlineoverridevirtual

The text in an editbox has been edited.

Parameters

  widget | The widget of the editbox.

Reimplemented from Window.

Definition at line 1312 of file newgrf_gui.cpp.

References avails, GUIList< T, P, F >::ForceRebuild(), Textbuf::GetText(), Window::InvalidateData(), StringFilter::IsEmpty(), GUIList< T, P, F >::SetFilterState(), StringFilter::SetFilterTerm(), string_filter, and WID_NS_FILTER.

## ◆ OnInvalidateData()

void NewGRFWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.

See also
  GameOptionsInvalidationData

Parameters

  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 1196 of file newgrf_gui.cpp.

References _settings_client, actives, avail_sel, avails, Compatible, Window::DisableWidget(), editable, FGCM_EXACT, FindGRFConfig(), GRFConfig::flags, GUIList< T, P, F >::ForceRebuild(), GCS_NOT_FOUND, GRFConfig::GetTextfile(), GRFConfig::GetURL(), GOID_NEWGRF_CHANGES_MADE, GOID_NEWGRF_CURRENT_LOADED, GOID_NEWGRF_LIST_EDITED, GOID_NEWGRF_RESCANNED, GRFIdentifier::grfid, GRFP_GRF_MASK, GRFP_GRF_UNSET, ClientSettings::gui, GRFConfig::ident, Invalid, GRFIdentifier::md5sum, GUISettings::newgrf_developer_tools, GRFConfig::num_valid_params, GRFConfig::original_md5sum, GRFConfig::palette, GUISettings::scenario_developer, Window::SetWidgetDisabledState(), Window::SetWidgetsDisabledState(), GRFConfig::status, BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Test(), UpdateScrollBars(), WID_NS_ADD, WID_NS_APPLY_CHANGES, WID_NS_CONTENT_DOWNLOAD, WID_NS_CONTENT_DOWNLOAD2, WID_NS_MOVE_DOWN, WID_NS_MOVE_UP, WID_NS_NEWGRF_TEXTFILE, WID_NS_OPEN_URL, WID_NS_PRESET_DELETE, WID_NS_PRESET_LIST, WID_NS_PRESET_SAVE, WID_NS_REMOVE, WID_NS_SET_PARAMETERS, WID_NS_TOGGLE_PALETTE, WID_NS_UPGRADE, and WID_NS_VIEW_PARAMETERS.

## ◆ OnKeyPress()

EventState NewGRFWindow::OnKeyPress | ( | char32_t | key,
|  | uint16_t | keycode
| ) |  |
| inlineoverridevirtual

A key has been pressed.

Parameters

  key | the Unicode value of the key.
  keycode | the untranslated key code including shift state.

Returns
  ES_HANDLED if the key press has been handled and no other window should receive the event.

Reimplemented from Window.

Definition at line 1294 of file newgrf_gui.cpp.

References avail_pos, avails, Window::CloseChildWindows(), CloseWindowByClass(), ES_HANDLED, ES_NOT_HANDLED, Window::InvalidateData(), Scrollbar::ScrollTowards(), Scrollbar::UpdateListPositionOnKeyPress(), WC_GRF_PARAMETERS, and WC_TEXTFILE.

## ◆ OnMouseDrag()

void NewGRFWindow::OnMouseDrag | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

An 'object' is being dragged at the provided position, highlight the target if possible.

Parameters

  pt | The point inside the window that the mouse hovers over.
  widget | The widget the mouse hovers over.

Reimplemented from Window.

Definition at line 1366 of file newgrf_gui.cpp.

References WidgetDimensions::framerect, Scrollbar::GetCount(), Scrollbar::GetScrolledRowFromWidget(), WidgetDimensions::scaled, Window::SetWidgetDirty(), WID_NS_AVAIL_LIST, WID_NS_FILE_LIST, and Coord2D< T >::y.

## ◆ OnNewGRFsScanned()

void NewGRFWindow::OnNewGRFsScanned | ( |  | ) |
| inlineoverridevirtual

Called whenever the NewGRF scan completed.

Implements NewGRFScanCallback.

Definition at line 1133 of file newgrf_gui.cpp.

References avails, Window::CloseChildWindows(), GUIList< T, P, F >::ForceRebuild(), WC_QUERY_STRING, and WC_TEXTFILE.

## ◆ OnQueryTextFinished()

void NewGRFWindow::OnQueryTextFinished | ( | std::optional< std::string > | str | ) |
| inlineoverridevirtual

The query window opened from this window has closed.

Parameters

  str | the new value of the string, `std::nullopt` if the window was cancelled or an empty string when the default button was pressed, i.e. `str->empty()`.

Reimplemented from Window.

Definition at line 1162 of file newgrf_gui.cpp.

References actives, GetGRFPresetList(), grf_presets, Window::InvalidateData(), and SaveGRFPresetToConfig().

## ◆ OnResize()

void NewGRFWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 781 of file newgrf_gui.cpp.

References WidgetDimensions::scaled, Scrollbar::SetCapacityFromWidget(), WID_NS_AVAIL_LIST, and WID_NS_FILE_LIST.

## ◆ TagNameFilter()

static bool NewGRFWindow::TagNameFilter | ( | const GRFConfig *const * | a,
|  | StringFilter & | filter
| ) |  |
| inlinestaticprivate

Filter grfs by tags/name.

Definition at line 1405 of file newgrf_gui.cpp.

References StringFilter::GetState(), and StringFilter::ResetState().

## ◆ UpdateScrollBars()

void NewGRFWindow::UpdateScrollBars | ( |  | ) |
| inline

Updates the scroll bars for the active and inactive NewGRF lists.

Definition at line 1183 of file newgrf_gui.cpp.

References actives, Scrollbar::ScrollTowards(), and Scrollbar::SetCount().

Referenced by OnInvalidateData().

## ◆ UpdateWidgetSize()

void NewGRFWindow::UpdateWidgetSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | const Dimension & | padding,
|  | Dimension & | fill,
|  | Dimension & | resize
| ) |  |
| inlineoverridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  | widget | Widget number.
  [in,out] | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  [in,out] | fill | Fill step of the widget.
  [in,out] | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 730 of file newgrf_gui.cpp.

References WidgetDimensions::framerect, WidgetDimensions::frametext, FS_NORMAL, GetCharacterHeight(), GetScaledSpriteSize(), GetString(), GetStringBoundingBox(), grf_presets, RectPadding::Horizontal(), maxdim(), Window::resize, WidgetDimensions::scaled, RectPadding::Vertical(), WID_NS_AVAIL_LIST, WID_NS_CONTENT_DOWNLOAD, WID_NS_CONTENT_DOWNLOAD2, WID_NS_FILE_LIST, WID_NS_NEWGRF_INFO, WID_NS_NEWGRF_INFO_TITLE, and WID_NS_PRESET_LIST.

## ◆ UpgradeCurrent()

void NewGRFWindow::UpgradeCurrent | ( |  | ) |
| inline

Upgrade the currently active set of NewGRFs.

Definition at line 703 of file newgrf_gui.cpp.

References _all_grfs, actives, Window::CloseChildWindows(), CloseWindowByClass(), FillGrfidMap(), WC_GRF_PARAMETERS, and WC_TEXTFILE.

Referenced by OnClick().

## Field Documentation

## ◆ active_over

int NewGRFWindow::active_over = -1

Active GRF item over which another one is dragged, `-1` if none.

Definition at line 622 of file newgrf_gui.cpp.

## ◆ active_sel

GRFConfig* NewGRFWindow::active_sel = nullptr

Selected active grf item.

Definition at line 615 of file newgrf_gui.cpp.

Referenced by DrawWidget(), NewGRFConfirmationCallback(), and OnClick().

## ◆ actives

GRFConfigList NewGRFWindow::actives {}

Temporary active grf list to which changes are made.

Definition at line 614 of file newgrf_gui.cpp.

Referenced by AddGRFToActive(), CanUpgradeCurrent(), Close(), DrawWidget(), NewGRFConfirmationCallback(), OnClick(), OnDragDrop(), OnDropdownSelect(), OnInvalidateData(), OnQueryTextFinished(), UpdateScrollBars(), and UpgradeCurrent().

## ◆ avail_pos

int NewGRFWindow::avail_pos = -1

Index of avail_sel if existing, else `-1`.

Definition at line 608 of file newgrf_gui.cpp.

Referenced by OnKeyPress().

## ◆ avail_sel

const GRFConfig* NewGRFWindow::avail_sel = nullptr

Currently selected available grf. `nullptr` is none is selected.

Definition at line 607 of file newgrf_gui.cpp.

Referenced by DrawWidget(), OnClick(), and OnInvalidateData().

## ◆ avails

GUIGRFConfigList NewGRFWindow::avails {}

Available (non-active) grfs.

Definition at line 606 of file newgrf_gui.cpp.

Referenced by AddGRFToActive(), DrawWidget(), NewGRFConfirmationCallback(), OnClick(), OnDropdownSelect(), OnEditboxChanged(), OnInvalidateData(), OnKeyPress(), and OnNewGRFsScanned().

## ◆ editable

bool NewGRFWindow::editable = false

Is the window editable?

Definition at line 618 of file newgrf_gui.cpp.

Referenced by OnInvalidateData(), and NWidgetNewGRFDisplay::SetupSmallestSize().

## ◆ EDITBOX_MAX_SIZE

const uint NewGRFWindow::EDITBOX_MAX_SIZE = 50
| static

Definition at line 599 of file newgrf_gui.cpp.

## ◆ execute

bool NewGRFWindow::execute = false

On pressing 'apply changes' are grf changes applied immediately, or only list is updated.

Definition at line 620 of file newgrf_gui.cpp.

## ◆ filter_editbox

QueryString NewGRFWindow::filter_editbox

Filter editbox;.

Definition at line 610 of file newgrf_gui.cpp.

## ◆ filter_funcs

const std::initializer_list< NewGRFWindow::GUIGRFConfigList::FilterFunction *const > NewGRFWindow::filter_funcs
| static

Initial value:
= {
&TagNameFilter,
}
NewGRFWindow::TagNameFilter
static bool TagNameFilter(const GRFConfig *const *a, StringFilter &filter)
Filter grfs by tags/name.
Definition newgrf_gui.cpp:1405

Filter functions of the GUIGRFConfigList.

Definition at line 1530 of file newgrf_gui.cpp.

## ◆ grf_presets

StringList NewGRFWindow::grf_presets {}

List of known NewGRF presets.

Definition at line 612 of file newgrf_gui.cpp.

Referenced by GetWidgetString(), OnClick(), OnDropdownSelect(), OnQueryTextFinished(), and UpdateWidgetSize().

## ◆ last_filtering

Filtering NewGRFWindow::last_filtering = {false, 0}
| static

Default filtering of GUIGRFConfigList.

Definition at line 1524 of file newgrf_gui.cpp.

## ◆ last_sorting

Listing NewGRFWindow::last_sorting = {false, 0}
| static

Default sorting of GUIGRFConfigList.

Definition at line 1523 of file newgrf_gui.cpp.

## ◆ modified

bool NewGRFWindow::modified = false

The list of active NewGRFs has been modified since the last time they got saved.

Definition at line 623 of file newgrf_gui.cpp.

Referenced by NewGRFConfirmationCallback().

## ◆ orig_list

GRFConfigList& NewGRFWindow::orig_list

List active grfs in the game. Used as initial value, may be updated by the window.

Definition at line 617 of file newgrf_gui.cpp.

Referenced by NewGRFConfirmationCallback().

## ◆ preset

int NewGRFWindow::preset = -1

Selected preset or `-1` if none selected.

Definition at line 621 of file newgrf_gui.cpp.

Referenced by GetWidgetString(), and OnClick().

## ◆ show_params

bool NewGRFWindow::show_params = false

Are the grf-parameters shown in the info-panel?

Definition at line 619 of file newgrf_gui.cpp.

## ◆ sorter_funcs

const std::initializer_list< NewGRFWindow::GUIGRFConfigList::SortFunction *const > NewGRFWindow::sorter_funcs
| static

Initial value:
= {
&NameSorter,
}
NewGRFWindow::NameSorter
static bool NameSorter(const GRFConfig *const &a, const GRFConfig *const &b)
Sort grfs by name.
Definition newgrf_gui.cpp:1391

Sort functions of the GUIGRFConfigList.

Definition at line 1526 of file newgrf_gui.cpp.

## ◆ string_filter

StringFilter NewGRFWindow::string_filter {}

Filter for available grf.

Definition at line 609 of file newgrf_gui.cpp.

Referenced by OnEditboxChanged().

## ◆ vscroll

Scrollbar* NewGRFWindow::vscroll = nullptr

Definition at line 625 of file newgrf_gui.cpp.

## ◆ vscroll2

Scrollbar* NewGRFWindow::vscroll2 = nullptr

Definition at line 626 of file newgrf_gui.cpp.

The documentation for this struct was generated from the following file:

- src/newgrf_gui.cpp